<template>
    <div>
        <header-layout></header-layout>
        <div class="w-100">
            <div class="max-w-7xl mx-auto py-6 px-4 sm:px-6 lg:px-8">
                <div class="mt-10 sm:mt-0">
                    <div class="md:grid md:grid-cols-3 md:gap-6">
                        <div class="md:col-span-1">
                            <div class="px-4 sm:px-0">
                                <h3 class="text-lg font-medium leading-6 text-gray-900">Ficha del nuevo vehículo</h3>
                                <p class="mt-1 text-sm text-gray-600">
                                    Aquí se pre visualizará la imagen del vehículo
                                </p>
                            </div>
                            <div v-if="vehicle.image_tmp" class="shadow overflow-hidden sm:rounded-md mt-3">
                                <img :src="vehicle.image_tmp" alt="" width="100%" height="100px" />
                            </div>
                            <div v-if="vehicle.image_tmp" class="mt-3 flex justify-end">
                                <button
                                    type="button"
                                    class="inline-flex justify-center py-2 px-4 border border-transparent shadow-sm text-sm font-medium rounded-md text-white bg-red-600 hover:bg-indigo-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-red-500"
                                    @click="deleteImg"
                                >
                                    Borrar
                                </button>
                            </div>
                        </div>
                        <div class="mt-5 md:mt-0 md:col-span-2">
                            <form action="#" method="POST" @submit.prevent="store">
                                <div class="shadow overflow-hidden sm:rounded-md">
                                    <div class="px-4 py-5 bg-white sm:p-6">
                                        <div class="grid grid-cols-6 gap-6">
                                            <div class="col-span-6 sm:col-span-3">
                                                <label for="brand_id" class="block text-sm font-medium text-gray-700">Marca</label>
                                                <select
                                                    id="brand_id"
                                                    name="brand_id"
                                                    class="mt-1 block w-full py-2 px-3 border border-gray-300 bg-white rounded-md shadow-sm focus:outline-none focus:ring-indigo-500 focus:border-indigo-500 sm:text-sm"
                                                    :class="{ 'border-red-600': errors.id_marca }"
                                                    :value="vehicle.brand_id"
                                                    @change="(event) => {
                                                        updateBrandId(event.target.value);
                                                        findModelsByBrand(event.target.value);
                                                    }"
                                                >
                                                    <option value="" disabled selected>Seleccione</option>
                                                    <option v-for="brand in brands" :value="brand.id">{{ brand.descripcion }}</option>
                                                </select>
                                                <span v-if="errors.id_marca" class="text-sm text-red-600 p-1">{{ errors.id_marca[0] }}</span>
                                            </div>

                                            <div class="col-span-6 sm:col-span-3">
                                                <label for="model_id" class="block text-sm font-medium text-gray-700">Modelo</label>
                                                <select
                                                    id="model_id"
                                                    name="model_id"
                                                    class="mt-1 block w-full py-2 px-3 border border-gray-300 bg-white rounded-md shadow-sm focus:outline-none focus:ring-indigo-500 focus:border-indigo-500 sm:text-sm"
                                                    :class="{ 'border-red-600': errors.id_modelo }"
                                                    :value="vehicle.model_id"
                                                    @change="(event) => updateModeldId(event.target.value)"
                                                >
                                                    <option value="" disabled selected>Seleccione</option>
                                                    <option v-for="model in brandModels" :value="model.id">{{ model.descripcion }}</option>
                                                </select>
                                                <span v-if="errors.id_modelo" class="text-sm text-red-600 p-1">{{ errors.id_modelo[0] }}</span>
                                            </div>

                                            <div class="col-span-6 sm:col-span-3">
                                                <label for="version" class="block text-sm font-medium text-gray-700">Versión</label>
                                                <input
                                                    type="text"
                                                    name="version"
                                                    id="version"
                                                    class="mt-1 block w-full py-2 px-3 border border-gray-300 bg-white rounded-md shadow-sm focus:outline-none focus:ring-indigo-500 focus:border-indigo-500 sm:text-sm"
                                                    :class="{ 'border-red-600': errors.version }"
                                                    :value="vehicle.version"
                                                    @input="(event) => updateVersion(event.target.value)"
                                                />
                                                <span v-if="errors.version" class="text-sm text-red-600 p-1">{{ errors.version[0] }}</span>
                                            </div>

                                            <div class="col-span-6 sm:col-span-3">
                                                <label for="year" class="block text-sm font-medium text-gray-700">Año</label>
                                                <input
                                                    type="number"
                                                    name="year"
                                                    id="year"
                                                    class="mt-1 block w-full py-2 px-3 border border-gray-300 bg-white rounded-md shadow-sm focus:outline-none focus:ring-indigo-500 focus:border-indigo-500 sm:text-sm"
                                                    :class="{ 'border-red-600': errors.anio }"
                                                    :value="vehicle.year"
                                                    @input="(event) => updateYear(event.target.value)"
                                                />
                                                <span v-if="errors.anio" class="text-sm text-red-600 p-1">{{ errors.anio[0] }}</span>
                                            </div>

                                            <div class="col-span-6 sm:col-span-3">
                                                <label for="kilometers" class="block text-sm font-medium text-gray-700">Kilometraje</label>
                                                <input
                                                    type="number"
                                                    name="kilometers"
                                                    id="kilometers"
                                                    class="mt-1 block w-full py-2 px-3 border border-gray-300 bg-white rounded-md shadow-sm focus:outline-none focus:ring-indigo-500 focus:border-indigo-500 sm:text-sm"
                                                    :class="{ 'border-red-600': errors.kilometraje }"
                                                    @input="(event) => updateKilometers(event.target.value)"
                                                    :value="vehicle.kilometers"
                                                />
                                                <span v-if="errors.kilometraje" class="text-sm text-red-600 p-1">{{ errors.kilometraje[0] }}</span>
                                            </div>

                                            <div class="col-span-6 sm:col-span-3">
                                                <label for="price" class="block text-sm font-medium text-gray-700">Precio</label>
                                                <input
                                                    type="number"
                                                    name="price"
                                                    id="price"
                                                    class="mt-1 block w-full py-2 px-3 border border-gray-300 bg-white rounded-md shadow-sm focus:outline-none focus:ring-indigo-500 focus:border-indigo-500 sm:text-sm"
                                                    :class="{ 'border-red-600': errors.precio }"
                                                    @input="(event) => updatePrice(event.target.value)"
                                                    :value="vehicle.price"
                                                />
                                                <span v-if="errors.precio" class="text-sm text-red-600 p-1">{{ errors.precio[0] }}</span>
                                            </div>

                                            <div class="col-span-6 sm:col-span-2">
                                                <label for="status" class="block text-sm font-medium text-gray-700">Estado</label>
                                                <select
                                                    id="status"
                                                    name="status"
                                                    class="mt-1 block w-full py-2 px-3 border border-gray-300 bg-white rounded-md shadow-sm focus:outline-none focus:ring-indigo-500 focus:border-indigo-500 sm:text-sm"
                                                    :class="{ 'border-red-600': errors.estado }"
                                                    :value="vehicle.status"
                                                    @change="(event) => updateStatus(event.target.value)"
                                                >
                                                    <option value="" disabled selected>Seleccione</option>
                                                    <option value="1">Activo</option>
                                                    <option value="0">Inactivo</option>
                                                </select>
                                                <span v-if="errors.estado" class="text-sm text-red-600 p-1">{{ errors.estado[0] }}</span>
                                            </div>

                                            <div class="col-span-6 sm:col-span-6">
                                                <label class="block text-sm font-medium text-gray-700">
                                                    Imagen portada
                                                </label>
                                                <div class="mt-1 flex justify-center px-6 pt-5 pb-6 border-2 border-gray-300 border-dashed rounded-md">
                                                    <div class="space-y-1 text-center">
                                                        <svg class="mx-auto h-12 w-12 text-gray-400" stroke="currentColor" fill="none" viewBox="0 0 48 48" aria-hidden="true">
                                                            <path d="M28 8H12a4 4 0 00-4 4v20m32-12v8m0 0v8a4 4 0 01-4 4H12a4 4 0 01-4-4v-4m32-4l-3.172-3.172a4 4 0 00-5.656 0L28 28M8 32l9.172-9.172a4 4 0 015.656 0L28 28m0 0l4 4m4-24h8m-4-4v8m-12 4h.02" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" />
                                                        </svg>
                                                        <div class="flex text-sm text-gray-600">
                                                            <label for="file-upload" class="relative cursor-pointer bg-white rounded-md font-medium text-indigo-600 hover:text-indigo-500 focus-within:outline-none focus-within:ring-2 focus-within:ring-offset-2 focus-within:ring-indigo-500">
                                                                <span>Suba una imagen</span>
                                                                <input id="file-upload" name="file-upload" accept="image/*" type="file" class="sr-only" @change="createImage" ref="img"/>
                                                            </label>
                                                            <p class="pl-1">o arrastre una</p>
                                                        </div>
                                                        <p class="text-xs text-gray-500">
                                                            PNG, JPG
                                                        </p>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="px-4 py-3 bg-gray-50 text-right sm:px-6">
                                        <button type="button" class="inline-flex justify-center py-2 px-4 border border-transparent shadow-sm text-sm font-medium rounded-md text-white bg-gray-600 hover:bg-gray-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500" @click="vehicles">
                                            Volver
                                        </button>
                                        <button type="submit" class="inline-flex justify-center py-2 px-4 border border-transparent shadow-sm text-sm font-medium rounded-md text-white bg-indigo-600 hover:bg-indigo-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500">
                                            Guardar
                                        </button>
                                    </div>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import HeaderLayout from "../../views/layout/Header";
import {mapActions, mapState} from "vuex";
import mapMutations from "vuex/dist/vuex.mjs";
import store from "../../store";
import {
    UPDATE_ERRORS_STORE,
    UPDATE_IMAGE_TMP_VEHICLE,
    UPDATE_IMAGE_VEHICLE
} from "../../store/modules/types/vehicleTypes";
export default {
    name: "Create",
    components: {HeaderLayout},
    mounted() {
      this.findBrands();
    },
    methods: {
        ...mapActions('vehicle', [
            'findBrands',
            'findModelsByBrand',
            'updateBrandId',
            'updateModeldId',
            'updateVersion',
            'updateYear',
            'updateKilometers',
            'updatePrice',
            'updateStatus',
            'vehicles',
            'store',
            'createImage',
        ]),
        deleteImg() {
            this.$refs.img.value = "";
            this.$store.commit(`vehicle/${UPDATE_IMAGE_VEHICLE}`, '');
            this.$store.commit(`vehicle/${UPDATE_IMAGE_TMP_VEHICLE}`, '');
        }
    },
    computed: {
        ...mapState('vehicle', {
            brands: state => state.brands,
            brandModels: state => state.brandModels,
            vehicle: state => state.vehicle,
            errors: state => state.errors,
        })
    }
}
</script>

<style scoped>

</style>
